﻿namespace Contracts
{
    /// <summary>
    /// Energy Consumer stuff.
    /// </summary>
    public interface IPowerConsumer
    {
        /// <summary>
        /// What the consumer does with the electricity.
        /// </summary>
        /// <returns>Just a message.</returns>
        string Start();

        /// <summary>
        /// Gets or sets the electricity supplier.
        /// </summary>
        IPowerSupplier PowerSupplier { get; set; }
    }
}
