﻿namespace Springfield
{
    using System.ComponentModel.Composition; // MEF
    using Contracts; // Power Supplier Contract

    /// <summary>
    /// Where Homer works.
    /// </summary>
    /// <remarks>
    /// Plays the role of 'Export Part' in the 
    /// Management Extensibility Framework.
    /// </remarks>
    [Export(typeof(IPowerSupplier))]
    public class NuclearPowerPlant : IPowerSupplier
    {
        /// <summary>
        /// Gets the source of energy.
        /// </summary>
        public string EnergySource
        {
            get
            {
                return "split atoms";
            }
        }
    }
}
