﻿namespace ThorntonBank
{
    using System.ComponentModel.Composition; // MEF
    using Contracts; // Power Supplier Contract

    /// <summary>
    /// Belgian Offshore Wind Farm.
    /// </summary>
    /// <remarks>
    /// Plays the role of 'Export Part' in the 
    /// Management Extensibility Framework.
    /// </remarks>
    [ExportMetadata(PowerSupplier.EnergyType, EnergyTypes.Renewable)]
    [Export(typeof(IPowerSupplier))]
    public class WindFarm : IPowerSupplier
    {
        /// <summary>
        /// Gets the source of energy.
        /// </summary>
        public string EnergySource
        {
            get
            {
                return "wind";
            }
        }
    }
}