﻿namespace U2UConsult.MEF.Sample
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Demonstration of the Managed Extensibility Framework.
    /// </summary>
    public class Program
    {
        /// <summary>
        /// Main entry point.
        /// </summary>
        /// <param name="args">Command line arguments.</param>
        public static void Main(string[] args)
        {
            Console.Title = "U2U Consult MEF Sample";

            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("\n .NET Managed Extensibility Framework Sample");
            Console.WriteLine(" " + new string('-', 98) + "\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("\n Dynamically composing an object graph:\n");
            Console.ForegroundColor = ConsoleColor.White;

            PowerPlug plug = new PowerPlug();
            Console.WriteLine(string.Format(" * {0}\n", plug.Consumer.Start()));

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("\n Importing many exports of the same contract:\n");
            Console.ForegroundColor = ConsoleColor.White;

            DistributionOperator elia = new DistributionOperator();

            foreach (var supplier in elia.Suppliers)
            {
                Console.WriteLine(
                    " * {0} {1} provides electricity from {2}.",
                    supplier.GetType().Namespace,
                    supplier.GetType().Name,
                    supplier.EnergySource);
            }

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("\n\n Exposing and accessing Metadata:\n");

            Console.ForegroundColor = ConsoleColor.White;

            foreach (var supplier in elia.KyotoFriendlySuppliers())
            {
                Console.WriteLine(
                     " * {0} {1} provides green electricity from {2}.",
                     supplier.GetType().Namespace,
                     supplier.GetType().Name,
                     supplier.EnergySource);
            }

            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("\n\n " + new string('-', 98));
            Console.WriteLine(new string(' ', 74) + "http://www.u2uconsult.com");

            Console.ReadKey();
        }
    }
}
